﻿/**
 * DISCLAIMER: The sample code or utility or tool described herein is provided on an "as is" basis, 
 * without warranty of any kind. UIDAI does not warrant or guarantee the individual success developers 
 * may have in implementing the sample code on their environment. 
 * 
 * UIDAI does not warrant, guarantee or make any representations of any kind with respect to the 
 * sample code and does not make any representations or warranties regarding the use, 
 * results of use, accuracy, timeliness or completeness of any data or information relating 
 * to the sample code. UIDAI disclaims all warranties, express or implied, and in particular, 
 * disclaims all warranties of merchantability, fitness for a particular purpose, and 
 * warranties related to the code, or any service or software related thereto. 
 * 
 * UIDAI is not responsible for and shall not be liable directly or indirectly for any 
 * direct, indirect damages or costs of any type arising out of use or any action 
 * taken by you or others related to the sample code. 
 * 
 * THIS IS NOT A SUPPORTED SOFTWARE.
 * 
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Net.Sf.Pkcs11;
using Net.Sf.Pkcs11.Wrapper;
using Net.Sf.Pkcs11.Params;
using Net.Sf.Pkcs11.Objects;
using System.Windows.Forms;
using Org.BouncyCastle.Crypto;
using Org.BouncyCastle.Crypto.Digests;
using Org.BouncyCastle.Crypto.Engines;
using Org.BouncyCastle.Crypto.Encodings;
using Org.BouncyCastle.Crypto.Parameters;
using Org.BouncyCastle.Security;
using Org.BouncyCastle.Asn1.Pkcs;
using Org.BouncyCastle.Asn1.Oiw;
using Org.BouncyCastle.Asn1.X509;
using Org.BouncyCastle.Asn1;
using Org.BouncyCastle.OpenSsl;

namespace ECDecryptor
{
    public class CSPDec
    {
        public byte[] Decrypt(byte[] message,byte[] pad, byte[] modulus)
        {
            Module module = Module.GetInstance(@"C:\WINDOWS\system32\aetpkss1.dll");
            module.Initialize();
  
            Slot[] slots = module.GetSlotList(true);
            
            if (slots.Length== 0)
            {
                MessageBox.Show("No slot available");
                return null;
            }

            Token token = null;
            for (int i = 0; i < slots.Length; i++)
            {
                if (slots[i].SlotInfo.IsTokenPresent)
                    token = slots[i].Token;
            }

            Session session = token.OpenSession(true);
           
            PIN pin = new PIN();
            pin.ShowDialog();

            // Executes the login passing the user PIN
            session.Login(UserType.USER,pin.Pin.ToCharArray());

            // Find RSA Private keys
            session.FindObjectsInit(new P11Attribute[]{new ObjectClassAttribute(CKO.PRIVATE_KEY),new KeyTypeAttribute(CKK.RSA)});
            P11Object[] keyObjects = session.FindObjects(10);

            RSAPrivateKey rsaPrivateKey = null;

            for (int i = 0; i < keyObjects.Length; i++)
            {
                rsaPrivateKey = (RSAPrivateKey)keyObjects[i];
                if (Utilities.CompareBytes(rsaPrivateKey.Modulus.Value, modulus))
                {
                    break;
                }
            }

            if (rsaPrivateKey== null)
            {
                MessageBox.Show(" No corresponding Private key found ");
                return null;
            }


            Mechanism decryptMech = new Mechanism(CKM.RSA_X_509);
            byte[] aeskey = null;

            try
            {
                //int enc = session.EncryptInit(m_encrypt, publicKey);
                //encBytes = session.Encrypt(input);
                // m_encrypt.Parameter = Encoding.UTF8.GetBytes("padd");
                session.DecryptInit(decryptMech,rsaPrivateKey);

                //byte[] dec = session.Decrypt(encBytes);
                byte[] dec = session.Decrypt(message);

                IAsymmetricBlockCipher cipher = new OaepEncoding(new RsaEngine(), new Sha256Digest(), pad);
                Org.BouncyCastle.Math.BigInteger mod = new Org.BouncyCastle.Math.BigInteger(1, rsaPrivateKey.Modulus.Value);
                Org.BouncyCastle.Math.BigInteger exp = new Org.BouncyCastle.Math.BigInteger("1", 16);
                RsaKeyParameters p_Temp = new RsaKeyParameters(false, mod, exp);

                cipher.Init(false, p_Temp);
                aeskey = cipher.ProcessBlock(dec, 0, dec.Length);

            }
            catch (Exception ex)
            { }
            finally
            {
                session.Logout();
                session.CloseSession();
            }
            return aeskey;
        }
    }
}
