﻿/**
 * DISCLAIMER: The sample code or utility or tool described herein is provided on an "as is" basis, 
 * without warranty of any kind. UIDAI does not warrant or guarantee the individual success developers 
 * may have in implementing the sample code on their environment. 
 * 
 * UIDAI does not warrant, guarantee or make any representations of any kind with respect to the 
 * sample code and does not make any representations or warranties regarding the use, 
 * results of use, accuracy, timeliness or completeness of any data or information relating 
 * to the sample code. UIDAI disclaims all warranties, express or implied, and in particular, 
 * disclaims all warranties of merchantability, fitness for a particular purpose, and 
 * warranties related to the code, or any service or software related thereto. 
 * 
 * UIDAI is not responsible for and shall not be liable directly or indirectly for any 
 * direct, indirect damages or costs of any type arising out of use or any action 
 * taken by you or others related to the sample code. 
 * 
 * THIS IS NOT A SUPPORTED SOFTWARE.
 * 
 */
using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Cryptware.NCryptoki;
using System.Security.Cryptography;
using Org.BouncyCastle.Crypto;
using Org.BouncyCastle.Crypto.Digests;
using Org.BouncyCastle.Crypto.Engines;
using Org.BouncyCastle.Crypto.Encodings;
using Org.BouncyCastle.Crypto.Parameters;
using Org.BouncyCastle.Security;
using Org.BouncyCastle.Asn1.Pkcs;
using Org.BouncyCastle.Asn1.Oiw;
using Org.BouncyCastle.Asn1.X509;
using Org.BouncyCastle.Asn1;
using Org.BouncyCastle.OpenSsl;

//using Net.Sf.Pkcs11;
//using Net.Sf.Pkcs11.Objects;

namespace ECDecryptor
{
    class CSPDecryption
    {
        public byte[] Decrypt(byte[] message,byte[] pad, byte[] modulus)
        {
            Cryptoki cryptoki = new Cryptoki(@"C:\WINDOWS\system32\aetpkss1.dll");
            cryptoki.Initialize();

            SlotList slots = cryptoki.Slots;
            if (slots.Count == 0)
            {
                MessageBox.Show("No slot available");
                return null;
            }

            Token token = null;
            for (int i = 0; i < slots.Count; i++)
            {
                if (slots[i].IsTokenPresent)
                    token = slots[i].Token;
            }

            // Searchs for an RSA private key object
            // Sets the template with its attributes
            CryptokiCollection template_PrivateKey = new CryptokiCollection();
            template_PrivateKey.Add(new ObjectAttribute(ObjectAttribute.CKA_CLASS, CryptokiObject.CKO_PRIVATE_KEY));
            template_PrivateKey.Add(new ObjectAttribute(ObjectAttribute.CKA_KEY_TYPE, Key.CKK_RSA));

            CryptokiCollection template_PublicKey = new CryptokiCollection();
            template_PublicKey.Add(new ObjectAttribute(ObjectAttribute.CKA_CLASS, CryptokiObject.CKO_PUBLIC_KEY));
            template_PublicKey.Add(new ObjectAttribute(ObjectAttribute.CKA_KEY_TYPE, Key.CKK_RSA));

            // Opens a read/write serial session
            Session session = token.OpenSession(Session.CKF_SERIAL_SESSION | SessionInfo.CKF_RW_SESSION);

            PIN pin = new PIN();
            pin.ShowDialog();

            // Executes the login passing the user PIN
            int nRes = session.Login(Session.CKU_USER,pin.Pin);
            if (nRes != 0)
            {
                MessageBox.Show("Wrong PIN");
                return null;
            }

            // Launchs the search specifying the template just created
            CryptokiCollection obj_PrivKey = session.Objects.Find(template_PrivateKey, 10);
            // Launchs the search specifying the template just created
            CryptokiCollection obj_PubKey = session.Objects.Find(template_PublicKey, 10);
            //CryptokiObjects o1 = session.Objects;

            RSAPrivateKey privateKey = null;
            //RSAPublicKey publicKey;
            //RSAPrivateKey tempKey=null;


            for (int i = 0; i < obj_PrivKey.Count; i++)
            {
                privateKey =(RSAPrivateKey)obj_PrivKey[i];
                if (Utilities.CompareBytes(privateKey.Modulus, modulus))
                {
                    break;
                }
            }
            

            if (privateKey == null)
            {
                MessageBox.Show(" No corresponding Private key found ");
                return null;
            }

            //privateKey = (RSAPrivateKey)obj_PrivKey[obj_PrivKey.Count - 1];
            //Console.WriteLine(privateKey.Label);

            //publicKey = (RSAPublicKey)obj_PubKey[obj_PubKey.Count - 1];
            //Console.WriteLine(publicKey.Label);
            //System.Windows.Forms.MessageBox.Show(Utilities.ParseByteArraytoHexString(publicKey.Modulus));
            //System.Windows.Forms.MessageBox.Show(Utilities.ParseByteArraytoHexString(privateKey.Modulus));
            
            Cryptware.NCryptoki.Mechanism m_encrypt = Mechanism.RSA_X_509;

            //m_encrypt.Set(Mechanism.CKG_MGF1_SHA256, Encoding.UTF8.GetBytes("pad"));
            //m_encrypt.Parameter = Encoding.UTF8.GetBytes("pad");
            //int ret =session.SignInit(m, privateKey);
            byte[] aeskey = null;
            try
            {
                //int enc = session.EncryptInit(m_encrypt, publicKey);
                //encBytes = session.Encrypt(input);
                // m_encrypt.Parameter = Encoding.UTF8.GetBytes("padd");
                int re = session.DecryptInit(Mechanism.RSA_X_509, privateKey);
 
               //byte[] dec = session.Decrypt(encBytes);
                byte[] dec = session.Decrypt(message);

                IAsymmetricBlockCipher cipher = new OaepEncoding(new RsaEngine(), new Sha256Digest(), pad);
                Org.BouncyCastle.Math.BigInteger mod=new Org.BouncyCastle.Math.BigInteger(1,privateKey.Modulus);
                Org.BouncyCastle.Math.BigInteger exp=new Org.BouncyCastle.Math.BigInteger("1",16);
                RsaKeyParameters p_Temp = new RsaKeyParameters(false, mod, exp);

                cipher.Init(false, p_Temp);
                aeskey = cipher.ProcessBlock(dec, 0, dec.Length);
             
            }
            catch (Exception ex)
            {}
            finally
            {
                session.Logout();
                session.Close();
            }
            return aeskey;
        }

        //public void LogMessage(string message)
        //{
        //    StreamWriter r = File.AppendText("C:\\Logg.txt");
        //    r.WriteLine(message);
        //    r.Close();
        //}

        //public void GeneratePublicKey(RSAPublicKey pub)
        //{
        //    byte[] pubExp = pub.PublicExponent;
        //    byte[] pubMod = pub.Modulus;

        //    string pubExpStr = Utilities.ParseByteArraytoHexString(pubExp);
        //    string pubModStr = Utilities.ParseByteArraytoHexString(pubMod);

        //}
    }
}
