﻿/**
 * DISCLAIMER: The sample code or utility or tool described herein is provided on an "as is" basis, 
 * without warranty of any kind. UIDAI does not warrant or guarantee the individual success developers 
 * may have in implementing the sample code on their environment. 
 * 
 * UIDAI does not warrant, guarantee or make any representations of any kind with respect to the 
 * sample code and does not make any representations or warranties regarding the use, 
 * results of use, accuracy, timeliness or completeness of any data or information relating 
 * to the sample code. UIDAI disclaims all warranties, express or implied, and in particular, 
 * disclaims all warranties of merchantability, fitness for a particular purpose, and 
 * warranties related to the code, or any service or software related thereto. 
 * 
 * UIDAI is not responsible for and shall not be liable directly or indirectly for any 
 * direct, indirect damages or costs of any type arising out of use or any action 
 * taken by you or others related to the sample code. 
 * 
 * THIS IS NOT A SUPPORTED SOFTWARE.
 * 
 */
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace Decryptor
{
    public partial class Form1 : Form
    {
        ECDecryptor.Decryptor dec ;
        string KeyStoreLocation;
        string EncryptedFileLoc;
        string DecryptedFileLoc;
        public Form1()
        {
            dec = new ECDecryptor.Decryptor();
            InitializeComponent();
            label3.Text = "";
        }

        private void button1_Click(object sender, EventArgs e)
        {
            label3.Text = "";
            dec = new ECDecryptor.Decryptor();
            dec.KeyStoreLocation = KeyStoreLocation;
            dec.Password = password_txt.Text;
            bool useUSBToken = radioButton2.Checked;
            if (EncryptedFileLoc == "" || EncryptedFileLoc == String.Empty || EncryptedFileLoc==null)
                label3.Text = "Specify location for Encryted File";
            else
            {
                byte[] inputBytes = File.ReadAllBytes(EncryptedFileLoc);
                
                if ((radioButton1.Checked) &&(KeyStoreLocation == "" || KeyStoreLocation == String.Empty || KeyStoreLocation==null))
                    label3.Text = "Specify location for Key Store File";
                else
                {
                    try
                    {
                        byte[] decryptedBytes = dec.decrypt(inputBytes,useUSBToken);
                        if (DecryptedFileLoc == "" || DecryptedFileLoc == String.Empty || DecryptedFileLoc == null)
                            label3.Text = "Specify location for Decrypted File";
                        else
                        {
                            File.WriteAllBytes(DecryptedFileLoc, decryptedBytes);
                            MessageBox.Show("Successful !");
                        }
                    }catch(Exception ex)
                    {
                        MessageBox.Show("Failed : " + ex.Message);
                    }
                }
            }
        }

        private void Browse_Click(object sender, EventArgs e)
        {
            openFileDialog1.ShowDialog();
            //dec.HasPrivateKey(openFileDialog1.FileName,);
        }

        private void Browse2_Click(object sender, EventArgs e)
        {
            openFileDialog2.ShowDialog();
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            KeyStoreLocation = textBox1.Text;
        }

        private void textBox2_TextChanged(object sender, EventArgs e)
        {
            EncryptedFileLoc = textBox2.Text;
        }

        private void button1_Click_1(object sender, EventArgs e)
        {
            saveFileDialog1.ShowDialog();
        }

        private void textBox3_TextChanged(object sender, EventArgs e)
        {
            DecryptedFileLoc = textBox3.Text;
        }

        private void password_txt_TextChanged(object sender, EventArgs e)
        {

        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton1.Checked)
            {
                groupBox1.Enabled = true;
            }
            else if (!radioButton1.Checked)
            {
                groupBox1.Enabled = false;
            }
        }
    }
}
