﻿/**
 * DISCLAIMER: The sample code or utility or tool described herein is provided on an "as is" basis, 
 * without warranty of any kind. UIDAI does not warrant or guarantee the individual success developers 
 * may have in implementing the sample code on their environment. 
 * 
 * UIDAI does not warrant, guarantee or make any representations of any kind with respect to the 
 * sample code and does not make any representations or warranties regarding the use, 
 * results of use, accuracy, timeliness or completeness of any data or information relating 
 * to the sample code. UIDAI disclaims all warranties, express or implied, and in particular, 
 * disclaims all warranties of merchantability, fitness for a particular purpose, and 
 * warranties related to the code, or any service or software related thereto. 
 * 
 * UIDAI is not responsible for and shall not be liable directly or indirectly for any 
 * direct, indirect damages or costs of any type arising out of use or any action 
 * taken by you or others related to the sample code. 
 * 
 * THIS IS NOT A SUPPORTED SOFTWARE.
 * 
 */
#region Namespaces
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
#endregion

namespace ECDecryptor
{
    /// <summary>
    /// General Utilities
    /// </summary>
    public class Utilities
    {
        /// <summary>
        /// Merges Two Byte Arrays
        /// </summary>
        /// <param name="byte2">ByteArray 2</param>
        /// <param name="byte1">ByteArray 1</param>
        /// <returns>Merged Byte Arrays</returns>
        public static byte[] MergeStream(byte[] byte2, byte[] byte1)
        {
            byte[] message = new byte[byte1.Length + byte2.Length];
            System.Array.Copy(byte1, 0, message, 0, byte1.Length);
            System.Array.Copy(byte2, 0, message, byte1.Length, byte2.Length);

            //System.arraycopy(byte1, 0, message, 0, byte1.length);
            //System.arraycopy(byte2, 0, message, byte1.length, byte2.length);
            return message;
        }

        public static bool CompareBytes(byte[] b1, byte[] b2)
        {
            bool equal = false;
            for (int i = 0; i < b1.Length; i++)
            {
                if (b1[i] == b2[i])
                    equal = true;

                else
                {
                    equal = false;
                    return equal;
                }

            }
            return equal;
        }

        public static string ParseHex(string hex)
        {
            char[] result = new char[hex.Length / 2];

            int hexIndex = 0;
            for (int i = 0; i < result.Length; i++)
            {
                result[i] = (char)(ParseHexDigit(hex[hexIndex++]) * 16 +
                ParseHexDigit(hex[hexIndex++]));
            }
            return new string(result);
        }
        public static byte[] ParseHexStringToByte(string hex)
        {
            byte[] result = new byte[hex.Length / 2];

            int hexIndex = 0;
            for (int i = 0; i < result.Length; i++)
            {
                result[i] = (byte)(ParseHexDigit(hex[hexIndex++]) * 16 +
                ParseHexDigit(hex[hexIndex++]));
            }
            return result;
        }

        public static int ParseHexDigit(char c)
        {
            if (c >= '0' && c <= '9')
            {
                return c - '0';
            }
            if (c >= 'a' && c <= 'f')
            {
                return c - 'a' + 10;
            }
            if (c >= 'A' && c <= 'F')
            {
                return c - 'A' + 10;
            }
            throw new ArgumentException("Invalid hex character");
        }

        /// <summary>
        /// Converts the numeric value of each element of a specified array of bytes to its equivalent Hex-String representation
        /// </summary>
        /// <param name="input">Input Byte Array</param>
        /// <returns>Hex String</returns>
        public static string ParseByteArraytoHexString(byte[] input)
        {
            string result = BitConverter.ToString(input);
            return result;
        }


        public static byte[][] split(byte[] source, int lengthOfFirst)
        {
            byte [] first = new byte[lengthOfFirst];
            byte [] second = new byte[source.Length - lengthOfFirst];
            Array.Copy(source, 0, first, 0, lengthOfFirst);
            Array.Copy(source, lengthOfFirst, second, 0, source.Length - lengthOfFirst);

            byte [][] finalByte = {first,second};

            
            return finalByte;
        }


    }
}

